Attribute VB_Name = "Debug_Modul"
Option Explicit

Private Const ShowDebugForm As Boolean = True

Private Const LogFile As String = "log.txt"

Private Const CreateLog As Integer = 3
'0 = nein
'1 = nur debug.print
'2 = nur logfile
'3 = beides

Private Type ClassInstanz
 Name As String
 Anzahl As Long
End Type
Private Instanzen() As ClassInstanz

Public Sub Log(ByVal Text As String)
 If Not ProgramIsRunning Then Exit Sub
 
 Select Case CreateLog
  Case 2, 3
   On Error GoTo ResumeIt 'bers Netzwerk treten hier manchmal Fehler auf, die beim nchsten Resume dann aber wieder weg sind
   Dim FileNum%
   FileNum% = FreeFile
   Open Verz + LogFile For Append As FileNum%
   Print #FileNum%, Text
   Close FileNum%
 End Select
 Select Case CreateLog
  Case 1, 3
   Debug.Print Text
 End Select
 If ShowDebugForm And Not Unloading Then DebugForm.AddText Text
 Exit Sub
 
ResumeIt:
 Resume
End Sub

Public Sub init_Debug()
 IfExistThenDelete Verz + "debugfile.prozesse"
 ReDim Instanzen(0) As ClassInstanz
 If ShowDebugForm Then
  Load DebugForm
  DebugForm.Show
 End If
End Sub

Public Sub NewInstanz(ByVal TheName As String)
 If Not ProgramIsRunning Then Exit Sub
 If Not ShowDebugForm Then Exit Sub
 If Unloading Then Exit Sub
 
 Dim X As Long
 For X = 1 To UBound(Instanzen)
  If Instanzen(X).Name = TheName Then
   Instanzen(X).Anzahl = Instanzen(X).Anzahl + 1
   DebugForm.ListView1.ListItems.Item(X).ListSubItems(1).Text = _
       LTrim$(RTrim$(Str$(Instanzen(X).Anzahl)))
   Exit Sub
  End If
 Next
 
 ReDim Preserve Instanzen(UBound(Instanzen) + 1) As ClassInstanz
 With Instanzen(UBound(Instanzen))
  .Name = TheName
  .Anzahl = 1
 End With
 DebugForm.ListView1.ListItems.Add UBound(Instanzen), , TheName
 DebugForm.ListView1.ListItems.Item(UBound(Instanzen)).ListSubItems.Add 1, , "1"
End Sub

Public Sub UnloadInstanz(ByVal TheName As String)
 If Not ProgramIsRunning Then Exit Sub
 If Not ShowDebugForm Then Exit Sub
 If Unloading Then Exit Sub
 
 Dim X As Long
 For X = 1 To UBound(Instanzen)
  If Instanzen(X).Name = TheName Then
   Instanzen(X).Anzahl = Instanzen(X).Anzahl - 1
   DebugForm.ListView1.ListItems.Item(X).ListSubItems(1).Text = _
       LTrim$(RTrim$(Str$(Instanzen(X).Anzahl)))
   Exit Sub
  End If
 Next
End Sub

Public Sub StartProzess(ByVal TheName As String)
 SetOption Verz + "debugfile.prozesse", _
           GetOption(Verz + "debugfile.prozesse") + TheName + "|"
 
 If Not ProgramIsRunning Then Exit Sub
 If Not ShowDebugForm Then Exit Sub
 If Unloading Then Exit Sub
 
 Dim Index As Long
 Index = GetIndexOfProzess(TheName)
 DebugForm.ListView2.ListItems.Item(Index).Tag = _
      LTrim$(RTrim$(Str$(timeGetTime()))) + "|" + _
      DebugForm.ListView2.ListItems.Item(Index).Tag
End Sub

Public Sub EndProzess(ByVal TheName As String)
 SetOption Verz + "debugfile.prozesse", _
           RemoveLastData(GetOption(Verz + "debugfile.prozesse"))
 
 If Not ProgramIsRunning Then Exit Sub
 If Not ShowDebugForm Then Exit Sub
 If Unloading Then Exit Sub

 Dim Index As Long
 Index = GetIndexOfProzess(TheName)
 Dim TheTime As Long
 Dim F As Long
 F = InStr(DebugForm.ListView2.ListItems.Item(Index).Tag, "|")
 TheTime = timeGetTime() - _
           Val(Left$(DebugForm.ListView2.ListItems.Item(Index).Tag, F - 1))
 DebugForm.ListView2.ListItems.Item(Index).Tag = _
      Right$(DebugForm.ListView2.ListItems.Item(Index).Tag, _
             Len(DebugForm.ListView2.ListItems.Item(Index).Tag) - F)
 DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(3).Text = _
      LTrim$(RTrim$(Str$(Val(DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(3).Text) + _
                         1)))
 DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(4).Text = _
      LTrim$(RTrim$(Str$(Val(DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(4).Text) + _
                         TheTime)))
 DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(1).Text = _
      LTrim$(RTrim$(Str$(Round(Val(DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(4).Text) / _
                               Val(DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(3).Text), 2))))
 If TheTime > Val(DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(2).Text) Then
  DebugForm.ListView2.ListItems.Item(Index).ListSubItems.Item(2).Text = _
       LTrim$(RTrim$(Str$(TheTime)))
 End If
End Sub

Private Function GetIndexOfProzess(ByVal TheName As String) As Long
 Debug.Assert LTrim$(RTrim$(TheName)) <> ""
 Dim X As Long
 For X = 1 To DebugForm.ListView2.ListItems.Count
  If DebugForm.ListView2.ListItems.Item(X).Text = TheName Then
   GetIndexOfProzess = X
   Exit Function
  End If
 Next
 
 Dim Temp As ListItem
 Set Temp = DebugForm.ListView2.ListItems.Add()
 Temp.Text = TheName
 Temp.ListSubItems.Add 1, , "0"
 Temp.ListSubItems.Add 2, , "0"
 Temp.ListSubItems.Add 3, , "0"
 Temp.ListSubItems.Add 4, , "0"
 GetIndexOfProzess = Temp.Index
End Function
