Attribute VB_Name = "FileIO_Code"
Option Explicit

Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Type WIN32_FIND_DATA
   dwFileAttributes   As Long
   ftCreationTime   As FILETIME
   ftLastAccessTime   As FILETIME
   ftLastWriteTime   As FILETIME
   nFileSizeHigh   As Long
   nFileSizeLow   As Long
   dwReserved0   As Long
   dwReserved1   As Long
   cFileName   As String * 255
   cAlternate   As String * 14
End Type

Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

Public Function GetFileInformations(ByVal TheFile As String) As String
 '1/300000 der Originalfile
 Dim FileNum%
 Dim Temp As String
 Dim F As Integer
 FileNum% = FreeFile
 Open TheFile For Binary Access Read As FileNum%
 Temp = Space$(Int(LOF(FileNum%) / 300000))
 If Not Temp = "" Then
  Get #FileNum%, Int(LOF(FileNum%) / 2), Temp
  F = InStr(Temp, "|")
  If F = 0 Then F = InStr(Temp, Chr$(13))
  If F = 0 Then F = InStr(Temp, Chr$(26))
  Do While Not F = 0
   Temp = Left$(Temp, F - 1) + Right$(Temp, Len(Temp) - F)
   F = InStr(Temp, "|")
   If F = 0 Then F = InStr(Temp, Chr$(13))
   If F = 0 Then F = InStr(Temp, Chr$(26))
  Loop
 End If
 Close FileNum%
 GetFileInformations = Temp
End Function

Public Function TestFile(ByVal TheFile As String) As Boolean
 On Error GoTo ErrorTestFile
 Dim FileNum%
 FileNum% = FreeFile
 Open TheFile For Binary As FileNum%
 Close FileNum%
 TestFile = True
 Exit Function
ErrorTestFile:
 TestFile = False
 Exit Function
End Function

Public Function DateiErweiterung(ByVal TheFile As String) As String
 TheFile = Replace(TheFile, "/", "\")
 Dim X As Integer
 X = Len(TheFile)
 Do While Not X < 1
  If Mid$(TheFile, X, 1) = "." Then
   DateiErweiterung = UCase$(Right$(TheFile, Len(TheFile) - X))
   Exit Function
  End If
  If Mid$(TheFile, X, 1) = "\" Then Exit Function
  X = X - 1
 Loop
End Function

Public Function GetFileName(ByVal TheFile As String) As String
 Dim X As Integer
 X = Len(TheFile)
 Do While Not X < 1
  If Mid$(TheFile, X, 1) = "\" Then
   GetFileName = Right$(TheFile, Len(TheFile) - X)
   Exit Function
  End If
  X = X - 1
 Loop
 GetFileName = TheFile
End Function

Public Function GetFilePath(ByVal TheFile As String) As String
 GetFilePath = Left$(TheFile, Len(TheFile) - Len(GetFileName(TheFile)))
End Function

Public Sub SetOption(ByVal TheFile As String, ByVal TheValue As String)
 Dim FileNum%
 FileNum% = FreeFile
 Open TheFile For Output As FileNum%
 Print #FileNum%, TheValue
 Close FileNum%
End Sub

Public Function GetOption(ByVal TheFile As String, Optional ByVal StandardValue As String) As String
 If Dir$(TheFile) = "" Then SetOption TheFile, StandardValue
 Dim FileNum%
 Dim Temp As String
 FileNum% = FreeFile
 Open TheFile For Input As FileNum%
 If Not EOF(FileNum%) Then Line Input #FileNum%, Temp
 Close FileNum%
 GetOption = Temp
End Function

Public Sub CreateFile(ByVal FileName As String)
 Dim FileNum%
 FileNum% = FreeFile
 Open FileName For Output As FileNum%
 Close FileNum%
End Sub

Public Sub IfNotExistThenCreate(ByVal FileName As String)
 If Dir$(FileName, 7) = "" Then CreateFile FileName
End Sub

Public Sub IfExistThenDelete(ByVal FileName As String)
 If Dir$(FileName) <> "" Then Kill FileName
End Sub

Public Sub WriteFile(ByVal TheFile As String, ByVal TheContent As String)
 IfExistThenDelete TheFile
 Dim FileNum%
 FileNum% = FreeFile
 Open TheFile For Binary Access Write As FileNum%
 Put #FileNum%, 1, TheContent
 Close FileNum%
End Sub

Public Function ReadFile(ByVal TheFile As String) As String
 Dim FileNum%
 FileNum% = FreeFile
 Open TheFile For Binary Access Read As FileNum%
 ReadFile = Space$(LOF(FileNum%))
 Get #FileNum%, 1, ReadFile
 Close FileNum%
End Function


