VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ProxyChecker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Parent As ProxyCheckers

Private WithEvents WebInterface As WebClient
Attribute WebInterface.VB_VarHelpID = -1
Private WithEvents CheckNextTimer As ATimer
Attribute CheckNextTimer.VB_VarHelpID = -1

Private myProxy As String

Public Sub Init(theParent As ProxyCheckers)
    Set WebInterface = New WebClient
    Set CheckNextTimer = New ATimer
    CheckNextTimer.Resolution = 30000
    CheckNextTimer.Delay = 300
    Set Parent = theParent
End Sub

Public Sub CheckProxy(theProxy As String)
    myProxy = theProxy
    WebInterface.SetProxy myProxy
    WebInterface.GetPage Parent.SiteURL
End Sub

Private Sub CheckNextTimer_Timer()
    CheckNextTimer.StoppTimer
    Parent.RaiseEvent_ReadyForNext Me
End Sub

Public Sub Cancel(Optional RaiseEvents As Boolean = True)
    WebInterface.Cancel
    Set WebInterface = Nothing
    CheckNextTimer.StoppTimer
    Set CheckNextTimer = Nothing
    If (myProxy <> "") And RaiseEvents Then
        Parent.RaiseEvent_ProxyCanceled myProxy
    End If
    Set Parent = Nothing
End Sub

Private Sub Class_Initialize()
    NewInstanz "ProxyChecker"
End Sub

Private Sub Class_Terminate()
    UnloadInstanz "ProxyChecker"
End Sub

Private Sub WebInterface_Closed()
    If WebInterface.answer_Number = 200 Then
        If Parent.OriginalPage = WebInterface.Data Then
            Log "neuer funktionierender Proxy: " + myProxy
            Parent.RaiseEvent_NewProxy myProxy
        Else
            Log "Proxy antwortet, aber nicht Original-Seite: " + myProxy
        End If
    Else
        Log "Proxy antwortet mit Fehler: " + myProxy
    End If
    Parent.RaiseEvent_ReadyForNext Me
End Sub

Private Sub WebInterface_Error(ByVal Number As Long, ByVal Description As String)
    Log "Fehler " + LTrim$(RTrim$(Str$(Number))) + " (" + Description + "): " + myProxy
    Parent.RaiseEvent_ReadyForNext Me
End Sub

Private Sub Log(Text As String)
    Parent.RaiseEvent_Log Text
End Sub
