VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ProxyCheckers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event ReadyForNext(Index As Long)
Public Event ProxyCanceled(theProxy As String)
Public Event Log(Text As String)
Public Event NewProxy(theProxy As String)

Private Checkers() As ProxyChecker

Public SiteURL As String
Public OriginalPage As String

Public Sub Init(theSiteURL As String, theOriginalPage As String)
    ReDim Checkers(0) As ProxyChecker
    SiteURL = theSiteURL
    OriginalPage = theOriginalPage
End Sub

Public Function GetCount() As Long
    GetCount = UBound(Checkers)
End Function

Public Sub Add(theProxy As String)
    ReDim Preserve Checkers(UBound(Checkers) + 1) As ProxyChecker
    Dim theChecker As ProxyChecker
    Set theChecker = New ProxyChecker
    Set Checkers(UBound(Checkers)) = theChecker
    theChecker.Init Me
    theChecker.CheckProxy theProxy
End Sub

Public Sub Remove(Optional RaiseEvents As Boolean = True, Optional Index As Long = 0)
    If Index = 0 Then Index = UBound(Checkers)
    Checkers(Index).Cancel RaiseEvents
    Set Checkers(Index) = Nothing
    Set Checkers(Index) = Checkers(UBound(Checkers))
    ReDim Preserve Checkers(UBound(Checkers) - 1) As ProxyChecker
End Sub

Public Sub RaiseEvent_ReadyForNext(theChecker As ProxyChecker)
    RaiseEvent ReadyForNext(getIndex(theChecker))
End Sub

Private Function getIndex(theChecker As ProxyChecker) As Long
    Dim i As Long
    For i = 1 To UBound(Checkers)
        If Checkers(i) Is theChecker Then
            getIndex = i
            Exit Function
        End If
    Next
End Function

Public Sub RaiseEvent_ProxyCanceled(theProxy As String)
    RaiseEvent ProxyCanceled(theProxy)
End Sub

Public Sub Cancel(Optional RaiseEvents As Boolean = True)
    Do While GetCount() > 0
        Remove RaiseEvents
    Loop
End Sub

Public Sub CheckProxy(Index As Long, theProxy As String)
    Checkers(Index).CheckProxy theProxy
End Sub

Public Sub RaiseEvent_Log(Text As String)
    RaiseEvent Log(Text)
End Sub

Private Sub Log(Text As String)
    RaiseEvent_Log Text
End Sub

Public Sub RaiseEvent_NewProxy(theProxy As String)
    RaiseEvent NewProxy(theProxy)
End Sub

Private Sub Class_Initialize()
    NewInstanz "ProxyCheckers"
End Sub

Private Sub Class_Terminate()
    UnloadInstanz "ProxyCheckers"
End Sub
