VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSocket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit


Event Connect()
Event Closed()
Event SendComplete()
Event DataArrival(BinData() As Byte, RemoteHostIP As String)
Event LineDataArrival(LineData As String, RemoteHostIP As String)
Event Error(Error As Long, Description As String)
Event ConnectionRequest()


Public SocketHandle&
Public State As sockType
Public LocalPort&
Public RemoteHost$
Public RemotePort&
Public LineSeparator$

Public SSLEnable As Boolean
Public SSLCipher$
Public SSLSubject$
Public SSLIssuer$
Public SSLServerCertificate$
Public SSLServerKey$
Public SSLTrusted As Boolean
Public SSLCAFile$

Public TimeOut As Integer '[ms]

Public WindowProcOld&
Public SSLHandle&
Public WindowHandle&
Private LineBuffer$

Public Sub Connect(ByVal Host As String, ByVal Port As Long)
    StartProzess "CSocket_Connect"
    
    If SocketHandle Then Disconnect
    StartWinsock
    
    SocketHandle = 0: SSLHandle& = 0: RemotePort& = 0
    State = sockConnecting
    SSLCipher$ = ""
    SSLSubject$ = ""
    SSLIssuer$ = ""
    SSLTrusted = False
    
    Dim sockin As sockaddr
    ClearSockAddr sockin
    sockin.sin_family = AF_INET
    sockin.sin_port = htons(Port)
    If sockin.sin_port = INVALID_SOCKET Then
     Disconnect
     StartProzess "Event CSocket_Error"
     RaiseEvent Error(1, "bad port")
     EndProzess "Event CSocket_Error"
     EndProzess "CSocket_Connect"
     Exit Sub
    End If
    
    sockin.sin_addr = GetHostByNameAlias(Host)
    If sockin.sin_addr = INADDR_NONE Then
     Disconnect
     StartProzess "Event CSocket_Error"
     RaiseEvent Error(2, "host not found")
     EndProzess "Event CSocket_Error"
     EndProzess "CSocket_Connect"
     Exit Sub
    End If
    
    SocketHandle = Socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)
    If SocketHandle <= 0 Then
     Disconnect
     StartProzess "Event CSocket_Error"
     RaiseEvent Error(3, "no sockethandle")
     EndProzess "Event CSocket_Error"
     EndProzess "CSocket_Connect"
     Exit Sub
    End If
    
    If LocalPort& > 0 Then
       Dim sockout As sockaddr
       ClearSockAddr sockout
       sockout.sin_family = AF_INET
       sockout.sin_port = htons(LocalPort&)
       If sockout.sin_port = INVALID_SOCKET Then
        Disconnect
        StartProzess "Event CSocket_Error"
        RaiseEvent Error(4, "invalid socket")
        EndProzess "Event CSocket_Error"
        EndProzess "CSocket_Connect"
        Exit Sub
       End If
       If bind(SocketHandle, sockout, sockaddr_size) Then
        Disconnect
        StartProzess "Event CSocket_Error"
        RaiseEvent Error(5, "error on binding")
        EndProzess "Event CSocket_Error"
        EndProzess "CSocket_Connect"
        Exit Sub
       End If
    End If
    'If SetSockLinger(SocketHandle, 1, 0) = SOCKET_ERROR Then Disconnect: Exit Sub
    
    If Not SSLEnable Then
       If WSAAsyncSelect(SocketHandle, WindowHandle&, CSocketMsg, FD_READ Or FD_WRITE Or FD_CONNECT Or FD_CLOSE) Then
        Disconnect
        StartProzess "Event CSocket_Error"
        RaiseEvent Error(6, "error on WSAAsyncSelect")
        EndProzess "Event CSocket_Error"
        EndProzess "CSocket_Connect"
        Exit Sub
       End If
       ConnectSocket SocketHandle, sockin, sockaddr_size
       If TimeOut Then SetTimer WindowHandle&, SocketHandle, TimeOut, 0
    Else
       If ConnectSocket(SocketHandle, sockin, sockaddr_size) Then
        Disconnect
        StartProzess "Event CSocket_Error"
        RaiseEvent Error(7, "error on connecting")
        EndProzess "Event CSocket_Error"
        EndProzess "CSocket_Connect"
        Exit Sub
       End If
       SSLHandle& = ssl_init_client(SocketHandle, SSLCAFile)
       If SSLHandle& = 0 Then
        Disconnect
        StartProzess "Event CSocket_Error"
        RaiseEvent Error(8, "error on initializing ssl")
        EndProzess "Event CSocket_Error"
        EndProzess "CSocket_Connect"
        Exit Sub
       End If
       WindowProc FD_CONNECT, 0
       If WSAAsyncSelect(SocketHandle, WindowHandle&, CSocketMsg, FD_READ Or FD_WRITE Or FD_CONNECT Or FD_CLOSE) Then
        Disconnect
        StartProzess "Event CSocket_Error"
        RaiseEvent Error(6, "error on WSAAsyncSelect")
        EndProzess "Event CSocket_Error"
        EndProzess "CSocket_Connect"
        Exit Sub
       End If
       SSLTrusted = ssl_getverify(SSLHandle&) = 0
    End If
    
    EndProzess "CSocket_Connect"
End Sub


Public Sub Listen()
    StartProzess "CSocket_Listen"
       
    If SocketHandle Then Disconnect
    StartWinsock
        
    SocketHandle = 0
    RemoteHost$ = ""
    RemotePort& = 0
    
    Dim sockin As sockaddr
    ClearSockAddr sockin
    sockin.sin_family = AF_INET
    sockin.sin_port = htons(LocalPort&)
    If sockin.sin_port = INVALID_SOCKET Then
     EndWinsock
     StartProzess "Event CSocket_Error"
     RaiseEvent Error(4, "invalid socket")
     EndProzess "Event CSocket_Error"
     EndProzess "CSocket_Listen"
     Exit Sub
    End If
    sockin.sin_addr = htonl(INADDR_ANY)
    If sockin.sin_addr = INADDR_NONE Then
     EndWinsock
     StartProzess "Event CSocket_Error"
     RaiseEvent Error(9, "invalid address")
     EndProzess "Event CSocket_Error"
     EndProzess "CSocket_Listen"
     Exit Sub
    End If
    
    SocketHandle = Socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)
    If SocketHandle <= 0 Then
     Disconnect
     StartProzess "Event CSocket_Error"
     RaiseEvent Error(3, "no sockethandle")
     EndProzess "Event CSocket_Error"
     EndProzess "CSocket_Listen"
     Exit Sub
    End If
    If bind(SocketHandle, sockin, sockaddr_size) Then
     Disconnect
     StartProzess "Event CSocket_Error"
     RaiseEvent Error(5, "error on binding")
     EndProzess "Event CSocket_Error"
     EndProzess "CSocket_Listen"
     Exit Sub
    End If
    
    If WSAAsyncSelect(SocketHandle, WindowHandle&, CSocketMsg, FD_READ Or FD_WRITE Or FD_CLOSE Or FD_ACCEPT) Then
     Disconnect
     StartProzess "Event CSocket_Error"
     RaiseEvent Error(6, "error on WSAAsyncSelect")
     EndProzess "Event CSocket_Error"
     EndProzess "CSocket_Listen"
     Exit Sub
    End If
    If listensocket(SocketHandle, 5) Then
     Disconnect
     StartProzess "Event CSocket_Error"
     RaiseEvent Error(10, "error on listening")
     EndProzess "Event CSocket_Error"
     EndProzess "CSocket_Listen"
     Exit Sub
    End If
    
    State = sockListening
    LocalPort& = GetLocalPort(SocketHandle)
    
    EndProzess "CSocket_Listen"
End Sub


Public Property Get LocalIP() As String
    LocalIP = AddrToIP$(GetLocalHost(SocketHandle))
End Property


Public Function SendData(Data As Variant) As Long
    StartProzess "CSocket_SendData"
    
    SendData = 0
    If SocketHandle = 0 Then
     EndProzess "CSocket_SendData"
     Exit Function
    End If
    
    Dim TheMsg() As Byte, sTemp$
    
    Select Case VarType(Data)
        Case 8209   'byte array
           sTemp = Data
           TheMsg = sTemp$
        Case 8      'string, if we recieve a string, its assumed we are in linemode
           sTemp = Data
           'Debug_Modul.Log "SendData: " + Chr$(34) + sTemp + Chr$(34)
           Log "< " + sTemp$
           TheMsg = StrConv(sTemp$ + LineSeparator$, vbFromUnicode)
        Case 17 'Byte
           ReDim TheMsg(0 To 0)
           TheMsg(0) = Data
        Case Else
           sTemp = CStr(Data)
           TheMsg = sTemp$
    End Select
    
    If UBound(TheMsg) > -1 Then
       'Debug.Print "send"; (UBound(TheMsg) - LBound(TheMsg) + 1)
       Dim p&, l&
       p& = LBound(TheMsg)
       Do While p& <= UBound(TheMsg) And SocketHandle <> 0
          If SSLHandle& = 0 Then
             l& = send(SocketHandle, TheMsg(p&), UBound(TheMsg) - p& + 1, 0)
          Else
             l& = ssl_send(SSLHandle&, TheMsg(p&), UBound(TheMsg) - p& + 1)
          End If
          If l& > 0 Then p& = p& + l&
          If l& = 0 Then Exit Do
       Loop
    End If
    
    EndProzess "CSocket_SendData"
End Function


Public Sub Disconnect()
    StartProzess "CSocket_Disconnect"
    State = sockClosed
    LocalPort = 0
    If SocketHandle Then
       If SSLHandle& Then ssl_cleanup SSLHandle&: SSLHandle& = 0
       KillTimer WindowHandle&, SocketHandle
       closesocket SocketHandle
       SocketHandle = 0
    End If
    EndWinsock
    EndProzess "CSocket_Disconnect"
End Sub


Public Sub Accept(MyServer As CSocket)
    Dim Sock As sockaddr
    SSLEnable = MyServer.SSLEnable
    SSLServerCertificate = MyServer.SSLServerCertificate
    SSLServerKey = MyServer.SSLServerKey
    
    StartWinsock
    
    SocketHandle = acceptsocket(MyServer.SocketHandle, Sock, sockaddr_size)
    
    If SSLEnable Then
       If WSAAsyncSelect(SocketHandle, WindowHandle, 0, 0) Then Disconnect: Exit Sub
       Dim l&: l& = 0
       If ioctlsocket(SocketHandle, FIONBIO, l&) Then Disconnect: Exit Sub
       SSLHandle& = ssl_init_server(SocketHandle, SSLServerCertificate$, SSLServerKey$): If SSLHandle& <= 100 Then Disconnect: Exit Sub
       If WSAAsyncSelect(SocketHandle, WindowHandle&, CSocketMsg, FD_READ Or FD_WRITE Or FD_CLOSE Or FD_ACCEPT) Then Disconnect: Exit Sub
    End If

    '??SetSockLinger SocketHandle, 1, 0
    RemoteHost$ = GetPeerHostByAddr(SocketHandle)
    RemotePort& = GetPeerPort(SocketHandle)
    If SocketHandle Then State = sockConnected
End Sub


Public Sub SendFile(file$)
Const Block = 5000
Dim F%, l&

F% = FreeFile
Open file$ For Binary Access Read As #F%
l& = LOF(F%)
If l& >= Block Then ReDim B(0 To Block - 1) As Byte
Do While l& > 0
   DoEvents
   If l& < Block Then ReDim B(0 To l& - 1)
   Get #F%, , B
   l& = l& - Block
   SendData B
Loop
Close #F%

End Sub


Public Sub WindowProc(WSAEvent As Long, Data As Variant)
    Dim er$
    
    Select Case WSAEvent
        Case 0
           er$ = Data
           StartProzess "Event CSocket_Error"
           RaiseEvent Error(0, er$)
           EndProzess "Event CSocket_Error"
           Disconnect
        Case FD_CLOSE
           Log "closed " & RemoteHost$ & ":" & RemotePort&
           StartProzess "Event CSocket_Closed"
           RaiseEvent Closed
           EndProzess "Event CSocket_Closed"
           Disconnect
        Case FD_CONNECT
           If RemotePort& Then Exit Sub
           RemoteHost$ = GetPeerHostByAddr(SocketHandle)
           RemotePort& = GetPeerPort(SocketHandle)
           Log ""
           Log "------------------------------------------------------"
           Log "connected " & RemoteHost$ & ":" & RemotePort&
           If SSLHandle& > 0 Then
               Dim puffer As String * 1000
               ssl_getcipher SSLHandle&, puffer, 1000: SSLCipher$ = parse$(puffer, Chr$(0))
               ssl_getsubject SSLHandle&, puffer, 1000: SSLSubject$ = parse$(puffer, Chr$(0))
               ssl_getissuer SSLHandle&, puffer, 1000: SSLIssuer$ = parse$(puffer, Chr$(0))
           End If
           LocalPort& = GetLocalPort(SocketHandle)
           State = sockConnected
           StartProzess "Event CSocket_Connect"
           RaiseEvent Connect
           EndProzess "Event CSocket_Connect"
        Case FD_ACCEPT
           StartProzess "Event CSocket_ConnectionRequest"
           RaiseEvent ConnectionRequest
           EndProzess "Event CSocket_ConnectionRequest"
        Case FD_READ
           Dim B() As Byte
           B = Data
           'Debug.Print "... " & (UBound(b) - LBound(b) + 1) & " Bytes received"
           'Debug.Print "... ";: For n% = LBound(b) To UBound(b): Debug.Print b(n);: Next: Debug.Print
           StartProzess "Event CSocket_DataArrival"
           If Len(LineSeparator$) = 0 Then
              'Log "> " + StrConv( B, vbUnicode)
              RaiseEvent DataArrival(B, RemoteHost)
           Else
              Dim line$, z$
              line$ = StrConv(B, vbUnicode)
              If InStr(line$, Chr$(0)) Then line$ = Left$(line$, InStr(line$, Chr$(0)) - 1)
              LineBuffer$ = LineBuffer$ + line$
              'Debug.Print "***"; LineBuffer$; "***": For i% = 1 To Len(LineBuffer$): Debug.Print Asc(Mid$(LineBuffer$, i%, 1));: Next: Debug.Print
              Do While InStr(LineBuffer$, LineSeparator$)
                 'Log "> " + Left$(LineBuffer$, InStr(LineBuffer$, LineSeparator$) - 1)
                 z$ = Left$(LineBuffer$, InStr(LineBuffer$, LineSeparator$) - 1)
                 LineBuffer$ = Mid$(LineBuffer$, InStr(LineBuffer$, LineSeparator$) + Len(LineSeparator$))
                 RaiseEvent LineDataArrival(z$, RemoteHost)
              Loop
           End If
           EndProzess "Event CSocket_DataArrival"
         Case FD_WRITE
           StartProzess "Event CSocket_SendComplete"
           RaiseEvent SendComplete
           EndProzess "Event CSocket_SendComplete"
    End Select
End Sub


Public Function MyIP() As String
   Dim ich$, adapter%, IP$, dnsname$, iplocal$, ipglobal$, ip0$, ip1%, ip2%, ip3%, ip4%
   
   MyIP = "": iplocal$ = "": ipglobal$ = ""
   StartWinsock
   ich$ = GetLocalHostName(): adapter% = 0
   Do
      IP$ = HostByName$(ich$, adapter%): If Len(IP$) = 0 Then Exit Do
      ip0$ = IP$: ip1% = Val(parse$(ip0$, ".")): ip2% = Val(parse$(ip0$, ".")): ip3% = Val(parse$(ip0$, ".")): ip4% = Val(ip0$)
      If (ip1% = 127 And ip2% = 0) Or (ip1% = 10) Or (ip1% = 172 And ip2% <= 16 And ip2% <= 31) Or (ip1% = 192 And ip2% = 168) Then
         iplocal$ = IP$
      Else
         ipglobal$ = IP$
      End If
      adapter% = adapter% + 1
   Loop
   If Len(ipglobal$) Then MyIP = ipglobal$ Else MyIP = iplocal$
   EndWinsock
End Function


Public Function MyName() As String
   StartWinsock
   MyName = GetLocalHostName()
   EndWinsock
End Function

'------------------------------------


Private Sub Class_Initialize()
 NewInstanz "CSocket"
    
    Sockets.Add Me
    WindowProcOld = 0
    WindowHandle& = 0
    
    State = sockClosed
    SocketHandle = 0
    LocalPort& = 0
    RemoteHost$ = ""
    RemotePort& = 0
    LineSeparator$ = ""
    SSLEnable = False
    TimeOut = 5000
End Sub

Private Sub Class_Terminate()
 UnloadInstanz "CSocket"
End Sub

Public Sub Cancel()
    Disconnect
    
    Dim n%
    For n% = 1 To Sockets.Count
       If Sockets(n%) Is Me Then Sockets.Remove n%: Exit For
    Next
End Sub

Private Sub StartWinsock()
    If usedcount% = 0 Then
       Dim StartupData As WSADataType
       If WSAStartup(257, StartupData) Then
          MsgBox "Winsock is not installed or Setup properly.", vbCritical, "Winsock Error"
       End If
       'Debug.Print "LowVersion = "; Trim$(StartupData.wVersion), "HighVersion="; Trim$(StartupData.wHighVersion)
       'Debug.Print "Description = "; Trim$(StartupData.szDescription)
       'Debug.Print "SystemStatus = "; Trim$(StartupData.szSystemStatus)
       'Debug.Print "Maximum Sockets = "; Trim$(StartupData.iMaxSockets)
    End If
    usedcount% = usedcount% + 1
    
    WindowHandle& = CreateWindowEx(0&, "static", "tst", WS_OVERLAPPEDWINDOW, 5&, 1&, 200&, 100&, 0&, 0&, App.hInstance, ByVal 0&)
    WindowProcOld& = SetWindowProc(WindowHandle&, 0)
End Sub


Private Sub EndWinsock()
    If WindowHandle& Then
       SetWindowProc WindowHandle&, WindowProcOld&
       WindowProcOld& = 0
       DestroyWindow WindowHandle&
       WindowHandle& = 0
       
       usedcount% = usedcount% - 1: If usedcount% = 0 Then WSACleanup
    End If
End Sub


Private Sub Log(l$)
   'Dim f%
   'f% = FreeFile: Open "c:\log.txt" For Append As #f%: Print #f%, l$: Close #f%
   'Debug.Print l$
End Sub

Private Function parse$(ByRef a$, ByVal s$)
   If InStr(a$, s$) Then
      parse$ = Left$(a$, InStr(a$, s$) - 1): a$ = Mid$(a$, InStr(a$, s$) + Len(s$))
   Else
      parse$ = a$: a$ = ""
   End If
End Function

