Attribute VB_Name = "Text_Code"
Option Explicit

Public Function ZTrim$(ByVal T$)
 '** Kappen von T$ am 0-Byte
 Dim Drin%
 Drin% = InStr(T$, vbNullChar)
 If Drin% Then
  ZTrim$ = Left$(T$, Drin% - 1)
 Else
  ZTrim$ = T$
 End If
End Function

Public Function AZLeft(ByVal Text As String, ByVal Lnge As Long, Optional ByVal NeueZeichen As String = " ") As String
 If Lnge > Len(Text) Then
  AZLeft = Text + String$(Lnge - Len(Text), NeueZeichen)
 Else
  AZLeft = Left$(Text, Lnge)
 End If
End Function

Public Function AZLeftGleich(ByVal MainText As String, ByVal CompareText As String) As Boolean
 AZLeftGleich = (AZLeft(MainText, Len(CompareText)) = CompareText)
End Function

Public Function AZRight(ByVal Text As String, ByVal Lnge As Long, Optional ByVal NeueZeichen As String = " ") As String
 If Lnge > Len(Text) Then
  AZRight = Text + String$(Lnge - Len(Text), NeueZeichen)
 Else
  AZRight = Right$(Text, Lnge)
 End If
End Function

Public Function AZRightGleich(ByVal MainText As String, ByVal CompareText As String) As Boolean
 AZRightGleich = (AZRight(MainText, Len(CompareText)) = CompareText)
End Function

Public Function Bytes2Text(ByVal AnzBytes As Double, Optional ByVal StellenHinterKomma As Integer = 2) As String
 If AnzBytes < 1000 Then
  Bytes2Text = LTrim$(RTrim$(Str$(Round(AnzBytes)))) + " B"
 Else
  If AnzBytes / 1024 < 1000 Then
   Bytes2Text = LTrim$(RTrim$(Str$(Round(AnzBytes / 1024, StellenHinterKomma)))) + " KB"
  Else
   If (AnzBytes / 1024) / 1024 < 1000 Then
    Bytes2Text = LTrim$(RTrim$(Str$(Round((AnzBytes / 1024) / 1024, StellenHinterKomma)))) + " MB"
   Else
    Bytes2Text = LTrim$(RTrim$(Str$(Round(((AnzBytes / 1024) / 1024) / 1024, StellenHinterKomma)))) + " GB"
   End If
  End If
 End If
End Function

Public Function Text2Bytes(ByVal Text As String) As Double
 Dim Zahl As Double
 Dim F As Long
 F = InStr(Text, " ")
 If F = 0 Then
  Text2Bytes = Val(Text)
  Exit Function
 End If
 Zahl = Val(Left$(Text, F - 1))
 Text = UCase$(LTrim$(RTrim$(Right$(Text, Len(Text) - F))))
 Select Case Text
  Case "KB"
   Zahl = Zahl * 1024
  Case "MB"
   Zahl = Zahl * 1024 * 1024
  Case "GB"
   Zahl = Zahl * 1024 * 1024 * 1024
 End Select
 Text2Bytes = Zahl
End Function

Public Function Time2Text(ByVal Sekunden As Long) As String
 Dim Stunden As Long
 Dim Minuten As Long
 Minuten = Int(Sekunden / 60)
 Sekunden = Sekunden - Minuten * 60
 Stunden = Int(Minuten / 60)
 Minuten = Minuten - Stunden * 60
 Time2Text = LTrim$(RTrim$(Str$(Stunden))) + ":" + _
             Right$("00" + LTrim$(RTrim$(Str$(Minuten))), 2) + ":" + _
             Right$("00" + LTrim$(RTrim$(Str$(Sekunden))), 2)
End Function

Public Function GetServerOfURLWithoutPort(ByVal URL As String) As String
 URL = Replace(URL, " ", "")
 If AZLeftGleich(UCase$(URL), "HTTP://") Then
  URL = Right$(URL, Len(URL) - 7)
 ElseIf AZLeftGleich(UCase$(URL), "FTP://") Then
  URL = Right$(URL, Len(URL) - 6)
 End If
 Dim F As Long
 F = InStr(URL, ":")
 If F = 0 Then F = InStr(URL, "/")
 If F = 0 Then
  GetServerOfURLWithoutPort = URL
 Else
  GetServerOfURLWithoutPort = Left$(URL, F - 1)
 End If
End Function

Public Function GetAnzahlData(ByVal Text As String, Optional ByVal Trennung As String = "|") As Long
 GetAnzahlData = 0
 Dim F As Long
 F = InStr(Text, Trennung)
 Do While F <> 0
  GetAnzahlData = GetAnzahlData + 1
  Text = Right$(Text, Len(Text) - F)
  F = InStr(Text, Trennung)
 Loop
End Function

Public Function GetOneData(ByVal Text As String, ByVal Index As Long, Optional ByVal Trennung As String = "|") As String
 Dim X As Long
 X = 0
 Dim F As Long
 F = InStr(Text, Trennung)
 Do While F <> 0
  X = X + 1
  If Index = X Then
   GetOneData = Left$(Text, F - 1)
   Exit Function
  End If
  Text = Right$(Text, Len(Text) - F)
  F = InStr(Text, Trennung)
 Loop
End Function

Public Function GetLastData(ByVal Text As String, Optional ByVal Trennung As String = "|") As String
 GetLastData = GetOneData(Text, GetAnzahlData(Text, Trennung), Trennung)
End Function

Public Function RemoveLastData(ByVal Text As String, Optional ByVal Trennung As String = "|") As String
 If Text = "" Then Exit Function
 RemoveLastData = Left$(Text, Len(Text) - Len(GetLastData(Text, Trennung) + "|"))
End Function
