VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WebClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Event DataArrival(NewData As String)
Public Event Closed()
Public Event NewHeader(TheHeader As OneHeader)
Public Event GetAnswer()
Public Event Error(ByVal Number As Long, ByVal Description As String)
Public Event StartOfDataArrival()

Public Data As String

Public answer_Version As String
Public answer_Number As Double
Public answer_Message As String
Public answer_Headers As WebClient_Header

Public ProxyServer As String
Public ProxyPort As Long

Private WithEvents Socket As CSocket
Attribute Socket.VB_VarHelpID = -1
Private WithEvents MyTimer As ATimer
Attribute MyTimer.VB_VarHelpID = -1

Private MyAddress As String
Private MyServer As String
Private myPort As Long
Private myCommand As String
Private myPage As String
Private myHTTPVersion As String
Private myReferer As String
Private myUserAgent As String
Private myContent As String
Private myContentType As String
Private myOtherHeaders As WebClient_Header
Private myCookies As httpCookie

Private Status As Integer

Private AllData As String

Public Sub GetPage(ByVal Adresse As String, Optional ByVal HTTP_Command As String = "GET", Optional ByVal HTTP_Version As String = "HTTP/1.0", Optional ByVal HTTP_Referer As String = "", Optional ByVal HTTP_UserAgent As String = "AZChat", Optional ByVal HTTP_Content As String = "", Optional ByVal HTTP_ContentType As String = "application/x-www-form-urlencoded", Optional otherHeaders As WebClient_Header, Optional HTTP_Cookies As httpCookie)
 StartProzess "WebClient_GetPage"
 
 Status = 0
 Data = ""
 AllData = ""
 answer_Headers.DeleteHeaders
 
 Dim F As Integer
 Dim HTTP_Server As String
 Dim HTTP_Page As String
 Dim HTTP_Port As Long
  
 If UCase$(Left$(Adresse, 7)) = "HTTP://" Then Adresse = Right$(Adresse, Len(Adresse) - 7)
 
 F = InStr(Adresse, "/")
 If F = 0 Then
  HTTP_Server = Adresse
  HTTP_Page = "/"
 Else
  F = F - 1
  HTTP_Server = Left$(Adresse, F)
  HTTP_Page = Right$(Adresse, Len(Adresse) - F)
 End If
 
 F = InStr(HTTP_Server, ":")
 If F = 0 Then
  HTTP_Port = 80
 Else
  HTTP_Port = Val(Right$(HTTP_Server, Len(HTTP_Server) - F))
  HTTP_Server = Left$(HTTP_Server, F - 1)
 End If
 
 MyAddress = "http://" + Adresse
 MyServer = HTTP_Server
 myPort = HTTP_Port
 myCommand = HTTP_Command
 myPage = HTTP_Page
 myHTTPVersion = HTTP_Version
 myReferer = HTTP_Referer
 myUserAgent = HTTP_UserAgent
 myContent = HTTP_Content
 myContentType = HTTP_ContentType
 Set myOtherHeaders = Nothing
 Set myCookies = Nothing
 
 If otherHeaders Is Nothing Then Set otherHeaders = GetEmptyHeader()
 Set myOtherHeaders = otherHeaders
 If HTTP_Cookies Is Nothing Then Set HTTP_Cookies = New httpCookie
 Set myCookies = HTTP_Cookies
 
 If ProxyServer = "" Then
  Socket.Connect HTTP_Server, HTTP_Port
 Else
  Socket.Connect ProxyServer, ProxyPort
 End If
 
 EndProzess "WebClient_GetPage"
End Sub

Private Sub Class_Initialize()
 NewInstanz "WebClient"
 
 Set Socket = New CSocket
 Set answer_Headers = New WebClient_Header
 Set MyTimer = New ATimer
 
 ProxyServer = default_ProxyServer
 ProxyPort = default_ProxyPort
End Sub

Private Sub Class_Terminate()
 Set MyTimer = Nothing
 Set answer_Headers = Nothing
 Set Socket = Nothing
 
 UnloadInstanz "WebClient"
End Sub

Private Sub MyTimer_Timer()
 'Timer aufgerufen von Again()
 
 MyTimer.StoppTimer
 
 If ProxyServer = "" Then
  Socket.Connect MyServer, myPort
 Else
  Socket.Connect ProxyServer, ProxyPort
 End If
End Sub

Private Sub Socket_Closed()
 StartProzess "Event WebClient_Closed"
 RaiseEvent Closed
 EndProzess "Event WebClient_Closed"
End Sub

Private Sub Socket_Connect()
 'Debug.Assert MyServer <> "80.143.110.140"
 Dim X As Long
 
 If ProxyServer = "" Then
  Socket.SendData myCommand + " " + myPage + " " + myHTTPVersion + endl
 Else
  Socket.SendData myCommand + " " + MyAddress + " " + myHTTPVersion + endl
 End If
 Socket.SendData "Referer: " + myReferer + endl
 Socket.SendData "Accept: */*" + endl
 If UCase$(myHTTPVersion) = "HTTP/1.1" Then Socket.SendData "Host: " + MyServer + IIf(myPort = 80, "", ":" + LTrim$(RTrim$(Str$(myPort)))) + endl
 Socket.SendData "User-Agent: " + myUserAgent + endl
 Socket.SendData "Accept-Language: de" + endl
 If Not myContent = "" Then
  Socket.SendData "Content-Length: " + LTrim$(RTrim$(Str$(Len(myContent)))) + endl
  Socket.SendData "Content-Type: " + myContentType + endl
 End If
 If Not myCookies.GetAnzahlCookies = 0 Then
  'Socket.SendData "Cookie: " + myCookies + endl
 End If
 For X = 1 To myOtherHeaders.Anzahl
  Socket.SendData myOtherHeaders.GetHeader(X).TheName + ": " + myOtherHeaders.GetHeader(X).TheValue + endl
 Next
 Socket.SendData "Connection: Close" + endl
 Socket.SendData endl
 If Not myContent = "" Then Socket.SendData myContent
End Sub

Private Sub Socket_DataArrival(BinData() As Byte, RemoteHostIP As String)
 Dim Temp As String
 Dim X As Integer
 Dim F As Integer
 Dim AktLine As String
 
 Temp = StrConv(BinData, vbUnicode)

 If Not Status = 2 Then
  AllData = AllData + Temp
 End If
 'Debug.Assert MyServer <> "80.143.110.140"
CheckNextData:
 If Not Status = 2 Then
  F = InStr(AllData, Chr$(10))
  If F = 0 Then Exit Sub
  AktLine = Replace(Left$(AllData, F - 1), Chr$(13), "")
  AllData = Right$(Temp, Len(AllData) - F)
 End If
 Select Case Status
  Case 0 'erste Daten
   F = InStr(AktLine, " ")
   If F = 0 Then Exit Sub
   answer_Version = Left$(AktLine, F - 1)
   AktLine = Right$(AktLine, Len(AktLine) - F)
   F = InStr(AktLine, " ")
   If F = 0 Then Exit Sub
   answer_Number = Val(Left$(AktLine, F - 1))
   AktLine = Right$(AktLine, Len(AktLine) - F)
   answer_Message = AktLine
   Status = 1
   StartProzess "Event WebClient_GetAnswer"
   RaiseEvent GetAnswer
   EndProzess "Event WebClient_GetAnswer"
   GoTo CheckNextData
  Case 1 'Headers
   If LTrim$(RTrim$(AktLine)) = "" Then
    Status = 2
    StartProzess "Event WebClient_StartOfDataArrival"
    RaiseEvent StartOfDataArrival
    EndProzess "Event WebClient_StartOfDataArrival"
    Data = Data + AllData
    If Not AllData = "" Then
     StartProzess "Event WebClient_DataArrival"
     RaiseEvent DataArrival(AllData)
     EndProzess "Event WebClient_DataArrival"
    End If
    Exit Sub
   Else
    F = InStr(AktLine, ": ")
    If F = 0 Then Exit Sub
    answer_Headers.NewHeader GetNewHeader(Left$(AktLine, F - 1), Right$(AktLine, Len(AktLine) - F - 1))
    StartProzess "Event WebClient_NewHeader"
    RaiseEvent NewHeader(answer_Headers.GetLastHeader())
    EndProzess "Event WebClient_NewHeader"
    GoTo CheckNextData
   End If
  Case 2 'Daten
   Data = Data + Temp
   StartProzess "Event WebClient_DataArrival"
   RaiseEvent DataArrival(Temp)
   EndProzess "Event WebClient_DataArrival"
 End Select
End Sub

Private Sub Socket_Error(Error As Long, Description As String)
 Socket.Disconnect
 StartProzess "Event WebClient_Error"
 RaiseEvent Error(Error, Description)
 EndProzess "Event WebClient_Error"
End Sub

Public Sub Again(Optional ByVal WaitTime As Long = 5000)
 MyTimer.Delay = WaitTime
 MyTimer.Resolution = 30000
 MyTimer.StartTimer
End Sub

Public Sub Cancel() 'muss vor Terminate ausgefhrt werden!
 If Not MyTimer Is Nothing Then MyTimer.StoppTimer
 If Not Socket Is Nothing Then Socket.Cancel
End Sub

Public Sub SetProxy(ByVal TheAddress As String)
 Dim F As Integer
 F = InStr(TheAddress, ":")
 If F = 0 Then
  ProxyServer = TheAddress
  ProxyPort = 8080
 Else
  ProxyServer = Left$(TheAddress, F - 1)
  ProxyPort = Val(Right$(TheAddress, Len(TheAddress) - F))
 End If
End Sub

Public Function GetAdresse() As String
 GetAdresse = MyAddress
End Function

Public Sub Disconnect()
 MyTimer.StoppTimer
 Socket.Disconnect
End Sub
